diff --git a/linux-2.6.37.6-antonio/ipc/snapshot.c b/linux-2.6.37.6-antonio/ipc/snapshot.c
index 2b6d35c..73afcbf 100644
--- a/linux-2.6.37.6-antonio/ipc/snapshot.c
+++ b/linux-2.6.37.6-antonio/ipc/snapshot.c
@@ -1,15 +1,559 @@
-/* snapshot/checkpoint and rollback
+/* snapshot
+ * checkpoint and rollback system calls
  * snapshot.c
  *
  *  Created on: Dec 7, 2011
  *      Author: Antonio Barbalace
  */
 
+/*
+ * the idea is to rollback kernel and user space components
+ * for user space, library support is required (maybe)
+ * we are going to hack a little bit to find out the best solution
+ * (but this is not on the critical pat for STM in kernel
+ */
+
+// kernel can call this function tring to restore a program that hangs up (this can be done under application control)
+// signals can use this facility. Like browsers
+
 #include <linux/syscalls.h>
 #include <linux/uaccess.h>
 
-SYSCALL_DEFINE6(ipc, unsigned int, call, int, first, unsigned long, second,
-		unsigned long, third, void __user *, ptr, long, fifth)
 
 
+//SYSCALL_DEFINE6(ipc, unsigned int, call, int, first, unsigned long, second,
+		//unsigned long, third, void __user *, ptr, long, fifth)
+
+/*SYSCALL_DEFINE0(getpid)
+{
+	return task_tgid_vnr(current);
+}*/
+
+/*int sys_fork(struct pt_regs *regs)
+{
+	return do_fork(SIGCHLD, regs->sp, regs, 0, NULL, NULL);
+}*/
+
+//syscall 341
+//i386 __NR_checkpoint 341
+/*
+ * TODO (what to do)
+ * arch/x86/kernel/syscall_table_32.S (sys_callback)
+ * arch/x86/include/asm/unistd_32.h REM to increment number
+ */
+//x86_64 __NR_checkpoint ?!?!
+/*
+ * TODO
+ * arch/x86/include/asm/unistd_64.h (__SYSCALL(__NR_checkpoint, sys_checkpoint) )
+ */
+/* experimental checkpoint as the way setjmp/longjmp do*/
+//SYSCALL_DEFINE2(rollback, key_t, key, int, msgflg)
+SYSCALL_DEFINE2(checkpoint, int, key, int, msgflg)
+{
+	/*
+	cosa voglio:
+
+	dettagli sul thread
+	dettagli sui registri
+	mi sa che dobbiamo di nuovo copiare
+	da do_fork
+*/
+	printk("SYSCALL_DEFINE2 checkpoint arg1 %d arg2 %d\n", key, msgflg);
+	return THREAD_SIZE;
+}
+
+
+//syscall 342
+//i386 __NR_rollback
+// pt_regs IS THE LAST ARGUMENT!!!
+/*
+ * TODO (what to do)
+ * arch/x86/kernel/syscall_table_32.S (ptregs_rollback)
+ * arch/x86/include/asm/unistd_32.h REM to increment number
+ * arch/x86/kernel/entry_32.S
+ */
+/*
+ * arch/x86/include/asm/unistd_64.h __SYSCALL(__NR_rollback, stub_rollback)
+ * arch/x86/kernel/entry_64.S
+ */
+//
+//int sys_fork(struct pt_regs *regs)
+//{ return do_fork(SIGCHLD, regs->sp, regs, 0, NULL, NULL); }
+int sys_rollback(int kkey, struct pt_regs *regs)
+{
+	printk("int sys_rollback arg1 %p arg2 %d\n", regs, kkey);
+	//show_regs(regs); //generate troubles
+	show_registers(regs); // still too verbose probably
+	//__show_regs(regs);
+
+	printk("user_mode_vm ret %d\n", user_mode_vm(regs));
+
+	printk("VM total %ld locked %ld shared %ld exec %ld stack %ld reserved %ld\n",
+			current->mm->total_vm, current->mm->locked_vm, current->mm->shared_vm,
+			current->mm->exec_vm, current->mm->stack_vm, current->mm->reserved_vm);
+	printk("def_flags %lx nr_ptes %ld\n",
+			current->mm->def_flags, current->mm->nr_ptes);
+	printk("CODE start %08lx end %08lx DATA start %08lx end %08lx BRK start %08lx %08lx STACK start %08lx\n",
+			current->mm->start_code, current->mm->end_code, current->mm->start_data, current->mm->end_data,
+			current->mm->start_brk, current->mm->brk, current->mm->start_stack);
+	printk("ARG start %08lx end %08lx ENV start %08lx end %08lx\n",
+			current->mm->arg_start, current->mm->arg_end, current->mm->env_start, current->mm->env_end);
+
+	unsigned long start;
+	struct mm_struct * mm = get_task_mm(current); //lock
+	struct vm_area_struct * vma = mm->mmap;
+	do {
+		start = 0;
+		if (vma->vm_flags & VM_GROWSDOWN) //qua assumono sempre che se ce qualcosa che ha l'opzione grows down e stack
+			if (!vma_stack_continue(vma->vm_prev, vma->vm_start))
+				start = vma->vm_start + PAGE_SIZE;
+
+		printk("%08lx-%08lx %c%c%c%c%c %08llx %8lx %s \n",
+				vma->vm_start,
+				vma->vm_end,
+				vma->vm_flags & VM_READ ? 'r' : '-',
+				vma->vm_flags & VM_WRITE ? 'w' : '-',
+				vma->vm_flags & VM_EXEC ? 'x' : '-',
+				vma->vm_flags & VM_MAYSHARE ? 's' : 'p',
+				vma->vm_flags & VM_GROWSDOWN ? 'd' : 'u',
+				vma->vm_file ? ((loff_t)vma->vm_pgoff) << PAGE_SHIFT : 0,
+				start,
+				vma->vm_file ? "file" : "none"
+				);
+	} while ( (vma = vma->vm_next) );
+	mmput(mm); //get_task_mm release mm is mmput
+
+	// NOTA in the file task_mmu.c they understand if the memory is stack or heap comparing it with start_stack or start_brk
+
+	// we need to obtain from user space the stack top address and copy the stack until the current sp,
+	// we cannot relay on kernel values for pthreads.. stack addr and stack size must be readed from user space
+
+	return kkey;
+}
+
+//#include <asm/uaccess.h>
+// copy_from_user
+
+#include <linux/errno.h>
+#include <linux/list.h>
+#include <linux/slab.h>
+
+#include <linux/snapshot.h>
+
+
+#include <asm/page.h>
+
+typedef struct __chk_pnt {
+	int index;
+	long flags;
+} chk_pnt;
+#define DEFAULT_FLAGS 0x0000
+
+//syscall 343
+//i386 __NR_snapshot
+// pt_regs IS THE LAST ARGUMENT!!!
+// TODO: future implementation details:
+/*
+ * future versions will implement
+ * secure page copies in swap o in protected memory areas (no iomapped hw regions)
+ * incremental snapshotting
+ */
+
+/*
+ * TODO (what to do)
+ * arch/x86/kernel/syscall_table_32.S (ptregs_rollback)
+ * arch/x86/include/asm/unistd_32.h REM to increment number
+ * arch/x86/kernel/entry_32.S
+ */
+/*
+ * arch/x86/include/asm/unistd_64.h __SYSCALL(__NR_rollback, stub_rollback)
+ * arch/x86/kernel/entry_64.S
+ */
+int PREVsys_snapshot(void* stackaddr, int stacksize, chk_pnt * chk_user_data, struct pt_regs *regs)
+{
+	chk_pnt user_data;
+	int ret = 0;
+
+	//check user address before access -> done by copy_from_user .. __must_ch
+	if (chk_user_data) { // if this is zero we cannot return index data and read flag data
+		// return bytes that cannot be copied
+		if ( (ret = copy_from_user(&user_data, chk_user_data, sizeof(chk_pnt))) )
+			printk("sys_snapshot error retrieving data from user space ret %d sizeof %d addr %p\n",
+					ret, sizeof(chk_pnt), chk_user_data); // error
+	} else
+		user_data.flags = DEFAULT_FLAGS;
+
+// GOAL: create a generic interface to the take_snapshot/rollback_snapshot
+// TODO move to incremental snapshots (TODO, idea: check last address if < check around last addr if same incremental enabled)
+// ARG: stackaddr, stacksize, flags, pt_regs RETURN handler or error -> 0
+	if (stackaddr) //switch work based on stackaddr
+	{ // if not zero the request is a checkpoint -------- process CHECKPOINT
+		void* stack_top = stackaddr + stacksize;
+		void* stack_curr = (void *) regs->sp;
+		unsigned long size = (unsigned long)stack_top - (unsigned long)stack_curr;
+		snapshot_t * psnap;
+		unsigned snapshot_size = 0;
+
+		//check stack addresses consistency
+		if ((stackaddr <= stack_curr) && (stack_curr <= stack_top))
+			printk("stack curr is in range! addr %p curr %p top %p size %ld\n",
+					stackaddr, stack_curr, stack_top, size);
+		else
+			//error
+			printk("stack curr is NOT in range! addr %p curr %p top %p size %ld\n",
+					stackaddr, stack_curr, stack_top, size);
+
+		// allocate a new checkpoint struct in current task_struct
+		// TODO round up snapshot_t  + round up size to align stack memory size
+		snapshot_size = (sizeof(snapshot_t) + size);
+		psnap = (snapshot_t *) kmalloc(snapshot_size, GFP_KERNEL);
+		if (!psnap) {
+			printk("sys_snapshot error kmalloc failed in requesting %d byte\n",
+					snapshot_size);
+			// something to return?
+			return -1;
+		}
+		memset((void*)psnap, 0, snapshot_size);
+		//INIT_HLIST_NODE()  same as memset..
+
+		psnap->usr_stack = stackaddr;
+		psnap->usr_stacksize = stacksize;
+		psnap->regs = *regs;
+		psnap->pad_stacksize = snapshot_size;
+
+		// stack copy from user space.. this is the only thing that could fail
+		if ( (ret = copy_from_user((void*) &(psnap[1]), stack_curr, size)) ) {
+			printk("sys_snapshot error copying user space stack in kernel ret %d (cannot be copied) size %d to %p from %p\n",
+					ret, size, &(psnap[1]), stack_curr); // error
+			//error
+			kfree((void*) psnap);
+			return -1;
+		}
+
+		hlist_add_head( &(psnap->next), &(current->snapshot) );
+		user_data.index = psnap; // save handler
+
+		// in the case of a checkpoint before returning must write to user the index num
+		if (chk_user_data)
+			if ( (ret = copy_to_user(chk_user_data, &user_data, sizeof(chk_pnt))) )
+				printk("sys_snapshot error writing data to user space ret %d sizeof %d\n",
+						ret, sizeof(chk_pnt)); // error
+
+		return 0; // on checkpoint if no error return is 0
+	} else
+
+//ARG:handler flags pt_regs RETURNS success or error
+	{ // if zero the request is a rollback -------- process ROLLBACK
+		//check if current process has snapshot
+		if (hlist_empty ( &(current->snapshot) ) ) {
+			//error
+			printk("rollback interface no snapshot for the current process\n");
+			return -1;
+		}
+		// we have to walk the list and find the handler
+		snapshot_t * tpos;
+		struct hlist_node * pos, * n;
+		hlist_for_each_entry_safe(tpos, pos, n, &(current->snapshot), next) {
+			if ( tpos == (snapshot_t *)user_data.index ) {
+				break;
+			}
+		}
+		if ( tpos != (snapshot_t *)user_data.index ) {
+			//error
+			printk("rollack interface no snapshots with the current handler %08x\n", user_data.index);
+			return -1;
+		}
+
+		//recalc stack size
+		void* stack_top = tpos->usr_stack + tpos->usr_stacksize;
+		unsigned long size = (unsigned long)stack_top - (unsigned long)tpos->regs.sp;
+
+		// TODO why not to match the current stack data before rollback?!?! (future todo)
+		if ( (ret = copy_to_user((void *) tpos->regs.sp, &(tpos[1]), size)) ) {
+				printk("sys_snapshot error writing STACK data to user space ret %d(cannot be copied). CRITICAL\n",
+						ret); // error
+		}
+
+		// if the handler exist then rollback snapshot user stack + ptregs
+		*regs = tpos->regs;
+
+		// eliminate the checkpoint or all checkpoints following what flags requires...
+		printk("rollback completed with sucess\n");
+
+		return stacksize; // on rollback return value depends on the user request (in stacksize var)
+	}
+}
+
+
+// new data structures from user space
+
+// the following data structures and defines are only reqiured to user space
+// and from the syscall entry point
+typedef struct __stack_struct {
+	void * addr;
+	long size;
+} stack_struct;
+
+typedef struct __user_struct {
+	//int index;
+	uintptr_t hnd; //snapshot handler (i.e. a pointer to snapshot_t -> snapshot_t *)
+	long flags;
+	int data; // return value for rollbacks.. and also for create.. this is specified by the user
+} user_struct;
+
+#define SNAP_CREATE		0x0010
+#define SNAP_DELETE		0x0020
+#define SNAP_RESTORE	0x0030
+
+//#define SNAP_DEBUG(a...) printk(a)
+#define SNAP_DEBUG(a...)
+
+/*
+ * sys_snapshot
+ * entry point for snapshotting functions
+ * NEW VERSION (REFACTORING 28jan2012)
+ * this new version uses stack_struct and user_struct
+ * calls the internal functions take_snapshot/revert_snapshot
+ * @ returns 0 on success otherwise error code
+ */
+//int sys_snapshot(void* stackaddr, int stacksize, chk_pnt * chk_user_data, struct pt_regs *regs)
+int sys_snapshot(int func, __user stack_struct * pstack, __user user_struct * puser, struct pt_regs *regs)
+{
+	snapshot_t * psnap;
+	stack_struct stack;
+	user_struct user;
+	int ret;
+
+	if ( !puser )
+		return -EINVAL;
+
+	// copy_from_user checks for user access consistency and returns bytes that cannot be copied
+	// first copy the stack data structure
+	memset(&stack, 0, sizeof(stack_struct));
+	if (pstack) {
+		if ( (ret = copy_from_user(&stack, pstack, sizeof(stack_struct))) )
+			printk("%s: warn copy_from_user(&stack failed %d (cannot be copied) size %d to %p from %p\n",
+					__func__, ret, sizeof(stack_struct), &stack, pstack);
+	}
+
+	// then copy the user data structure
+	memset(&user, 0, sizeof(user_struct));
+	if (puser) { // if this is zero we cannot return index data and read flag data
+		if ( (ret = copy_from_user(&user, puser, sizeof(user_struct))) )
+			printk("%s: warn copy_from_user(&user failed %d (cannot be copied) size %d to %p from %p\n",
+					__func__, ret, sizeof(user_struct), &user, &puser);
+	}
+
+	// function demultiplexer
+	switch (func) {
+	// snapshot create function, returns error on parameters and memory not allocated
+	case SNAP_CREATE: {
+		if ( !pstack )
+			return -EINVAL;
+		if ( (psnap = create_snapshot(stack.addr, stack.size, user.flags, regs)) == 0)
+			return -ENOMEM;
+
+		user.hnd = psnap;
+			if ( (ret = copy_to_user(puser, &user, sizeof(user_struct))) ) {
+				printk("%s: error copy_to_user failed with %d (cannot be copied) size %d from %p to %p\n",
+						__func__, ret, sizeof(chk_pnt), &user, puser); // error
+				return -ENOMEM;
+			}
+
+		break;
+	}
+	// snapshot restore function, returns error on snapshot not found
+	case SNAP_RESTORE: {
+		if ( (psnap = restore_snapshot(user.hnd, user.flags, regs)) == 0)
+			return -ENODEV;
+		break;
+	}
+	// snapshot delete lets the user delete the recorded snapshot for space efficiency
+	case SNAP_DELETE: {
+		if ( (ret = delete_snapshot(user.hnd, user.flags)) == 0)
+			return -ENODEV;
+		return ret;
+	}
+	// default case we left signaling a warning in the console log message
+	default:
+		printk("%s: warn function %d not supported\n",
+				__func__, func);
+		return -EINVAL;
+	}
+
+	// we save the actual snapshot_t pointer and copy user_data back in user space
+/*	user.hnd = psnap;
+	if ( (ret = copy_to_user(puser, &user, sizeof(user_struct))) ) {
+		printk("%s: critical error copy_to_user failed with %d (cannot be copied) size %d from %p to %p\n",
+				__func__, ret, sizeof(chk_pnt), &user, puser); // error
+		return -ENOMEM;
+	}
+*/	return user.data; // we always return what the user has specified in the .data field
+}
+
+// GOAL: take_snapshot must do the minimum from user space (because must be called from any other kernel point)
+
+// GOAL: create a generic interface to the take_snapshot/rollback_snapshot
+// TODO move to incremental snapshots (TODO, idea: check last address if < check around last addr if same incremental enabled)
+// ARG: stackaddr, stacksize, flags, pt_regs RETURN handler or error -> 0
+//return original pointer to the registered structure
+//we save together regs and stack no memory blocks.. all other stuff contained in the struct_task must be saved
+
+// NEXT VERSION must ensure that no one of the other threads of the process is accessing the memory
+//we are going to copy from user space!
+
+// move documentation in sthe h file
+/**
+ * take_snapshot
+ * @param
+ * @return
+ */
+snapshot_t * create_snapshot(__user void * stackaddr, long stacksize, unsigned long flags, struct pt_regs * regs)
+{
+	void* stack_top = stackaddr + stacksize;
+	void* stack_curr = (void *) regs->sp;
+	unsigned long stack_size = (unsigned long)stack_top - (unsigned long)stack_curr;
+	unsigned snap_size = 0;
+	unsigned ret = 0;
+	snapshot_t * psnap;
+
+	//check stack addresses consistency
+	if ((stackaddr <= stack_curr) && (stack_curr <= stack_top)) {
+		SNAP_DEBUG("%s: info stack curr IS in range addr %p curr %p top %p size %ld pid %d\n",
+			__func__, stackaddr, stack_curr, stack_top, stack_size, current->pid);
+	}
+	else {
+		//error
+		printk("%s: error stack curr IS NOT in range addr %p curr %p top %p size %ld pid %d\n",
+				__func__, stackaddr, stack_curr, stack_top, stack_size, current->pid);
+		return NULL;
+	}
+
+	// allocate a new snapshot struct that holds the stack copy too
+	snap_size = (sizeof(snapshot_t) + stack_size);
+	// roundup to page size (ceil)
+	snap_size = ((snap_size / PAGE_SIZE) +1) << PAGE_SHIFT;
+	// NOTE kmalloc supports maximum of 128kB
+	psnap = (snapshot_t *) kmalloc(snap_size, GFP_KERNEL);
+	if (!psnap) {
+		printk("%s: error kmalloc failed requesting %d byte\n",
+				__func__, snap_size);
+		return NULL;
+	}
+	memset((void*)psnap, 0, snap_size);
+	psnap->usr_stack = stackaddr;
+	psnap->usr_stacksize = stacksize;
+	psnap->regs = *regs;
+	psnap->pad_stacksize = snap_size;
+
+	// TODO incremental stack snapshot support
+
+	// copy stack from user space (this could fail)
+	if ( (ret = copy_from_user((void*) &(psnap[1]), stack_curr, stack_size)) ) {
+		printk("%s: error copy_from_user failed with %d (cannot be copied) size %d to %p from %p pid %d\n",
+				__func__, ret, stack_size, &(psnap[1]), stack_curr, current->pid);
+		//error free the allocated structures
+		kfree((void*) psnap);
+		return NULL;
+	}
+
+	// add the snapshot to the list of snapshot in struct task_struct
+	hlist_add_head( &(psnap->next), &(current->snapshot) );
+	return psnap;
+}
+
+
+//ARG:handler flags pt_regs RETURNS success or error
+// returned/reverted snapshot must be freed?!? --> no add another api to delete snapshot or add flag to revert and delete snapshot
+//
+snapshot_t * restore_snapshot (snapshot_t * snap, unsigned long flags, struct pt_regs * regs)
+{
+	int ret = 0;
+	snapshot_t * tpos;
+	struct hlist_node * pos, * n;
+	void* stack_top;
+	unsigned long stack_size;
+
+	//check if current process has snapshot
+	if (hlist_empty ( &(current->snapshot) ) ) {
+		//error
+		printk("%s: error no snapshot registered in the current process\n",
+				__func__);
+		return NULL;
+	}
+	// we have to walk the list and find the handler
+	hlist_for_each_entry_safe(tpos, pos, n, &(current->snapshot), next) {
+		if ( tpos == snap ) {
+			break;
+		}
+	}
+	// check if the snapshot really exist
+	if ( tpos != snap ) { //error
+		printk("%s: error no snapshots with the current handler %08x\n",
+				__func__, snap);
+		return NULL;
+	}
+
+	// recalc stack size from saved data
+	stack_top = tpos->usr_stack + tpos->usr_stacksize;
+	stack_size = (unsigned long)stack_top - (unsigned long)tpos->regs.sp;
+
+	// TODO why not to match the current stack data before rollback?!?! (future todo)
+	if ( (ret = copy_to_user((void *) tpos->regs.sp, &(tpos[1]), stack_size)) ) {
+		printk("%s: error copy_to_user failed with %d (cannot be copied) size %d from %p to %p pid %d\n",
+				__func__, ret, stack_size, &(tpos[1]), (void *) tpos->regs.sp, current->pid); // error
+		return NULL;
+	}
+	// revert to the previous register set
+	*regs = tpos->regs;
+
+	// we choose to do not eliminate here the checkpoint
+	SNAP_DEBUG("%s: info completed successfully pid %d\n",
+			__func__, current->pid);
+	return tpos;
+}
+
+int delete_snapshot(snapshot_t * psnap, unsigned long flag)
+{
+	int count = 0;
+	snapshot_t * tpos;
+	struct hlist_node * pos, * n;
+
+	// if no elements in the list return error
+	if (hlist_empty ( &(current->snapshot) ) )
+		return -ENODEV;
+
+
+
+	// we have to walk the list and find the handler (_safe against removals)
+	hlist_for_each_entry_safe(tpos, pos, n, &(current->snapshot), next) {
+		hlist_del( &(tpos->next) );
+		kfree(tpos);
+	}
+	return count;
+}
+
+
+// the following is to be used not in task context
+
+
+// TODO flags
+// TODO next release: delete checkpoint list with FLAGS
+// TODO next version incremental snapshots (after full integration)
+// TODO signals rollback
+// TODO file roll back
+
+int exit_snapshot(struct task_struct * tsk)
+{
+	if (hlist_empty ( &(tsk->snapshot) ) )
+		return 0;
 
+	// we have to walk the list and find the handler (_safe against removals)
+	snapshot_t * tpos;
+	struct hlist_node * pos, * n;
+	hlist_for_each_entry_safe(tpos, pos, n, &(tsk->snapshot), next) {
+		hlist_del( &(tpos->next) );
+		kfree(tpos);
+	}
+	return 0;
+}
